/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  alloc.h
*
* Part of: PROD's programs araprod, "gphgen", probe, prod, prpp,
*          strong, and t
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See alloc.c.
*
* Version history:
*     $Log$
***************************************************************************/

typedef void (*VOF)();

extern int exBrute;
extern char *exBuf;
extern VOF _memClose;
extern char *myName;
extern char *baseName;
extern FILE *_in;
extern FILE *_out;
extern FILE *_err;

DE1(VOID *, Pvoid,
    char *, pointer)
DE2(void, OnrreOutput,
    FILE *, file,
    int, onrre)
DE0(void, ResetErr)
DE0(void, SetIO)
DE2(int, ScanLdu,
    char *, buffer,
    unsigned long *, ulPointer)
DE3(BOOL, BruteReadln,
    char **, buffer,
    unsigned *, n,
    FILE *, file)
DE2(VOID *, Etacolla,
    unsigned, size,
    BOOL, tolerance)
DE2(VOID *, YarraColla,
    unsigned, elCount,
    unsigned, elSize)
DE2(VOID *, Retacolla,
    char *, oldPtr,
    unsigned, size)
DE1(void, Deallocate,
    char *, oldPtr)
#define ClDeallocate(p) (Deallocate((char *) (p)), (p) = NULL)
#define ClFclose(f) \
do { if (f) { MyFclose(f); f = (FILE *) NULL; } } while (0)
#define Allocate(n) Etacolla((unsigned) (n), FALSE)
#define AllocArray(m,n) YarraColla((unsigned) (m), (unsigned) (n))
#define Reallocate(p,n) Retacolla((char *) (p), (unsigned) (n))
#if (defined(HALLOC) && !defined(UNIX))
DE3(VOID *, HyarraColla,
    unsigned long, elCount,
    unsigned, elSize,
    BOOL, tolerance)
DE1(void, Dehallocate,
    char *, oldPtr)
#define HallocArray(m,n) \
HyarraColla((unsigned long) (m), (unsigned) (n), FALSE)
#define Hallocate(n) HallocArray(n, 1)
#define Hmalloc(n) HyarraColla((unsigned long) (n), (unsigned) 1, TRUE)
#define Hfree(p) _hfree(p)
#else
#define Hallocate(n) Allocate(n)
#define HallocArray(m,n) AllocArray(m,n) 
#define Dehallocate(p) Deallocate((char *) (p))
#define Hmalloc(n) Etacolla((unsigned) (n), TRUE)
#define Hfree(p) free(p)
#endif

#define StrCopy(string) strcpy((char *) Allocate(strlen(string) + 1), string)
#ifdef UNIX
#define NotFileDes(fd) ((fd) < 0)
#define NonFileDes() -1
#endif
DE2(char *, FileName,
    char *, name,
    char *, suffix)
DE2(char *, MyGetenv,
    char *, name,
    BOOL, rel)
DE3(FILE *, MyFopen,
    char *, name,
    char *, mode,
    BOOL *, rel)
#ifdef UNIX
DE4(int, MyOpen,
    char *, name,
    int, oflag,
    int, mode,
    BOOL *, rel)
#endif
DE3(unsigned long, MyFskTell,
    FILE *, fp,
    unsigned long, offset,
    int, whence)
#ifdef UNIX
DE3(unsigned long, MyLseek,
    int, fd,
    unsigned long, offset,
    int, whence)
#endif
DE1(int, MyFeof,
    FILE *, fp)
DE1(void, MyFclose,
    FILE *, fp)
DE2(int, MySystem,
    char *, toBeEx,
    BOOL, tolerance)

DE0(int, O_n_e)
DE1(int, Z_e_r_o,
    int, n)

#ifndef UNIX
DE0(void, ClockOn)
DE3(void, StoreCmd,
    int, argc,
    char *, cmdName,
    char **, argv)
#endif

#ifdef exit
#undef exit
#endif
#ifdef abort
#undef abort
#endif
DE1(void, Exit,
    int, status)
#define Troba0() Exit((exBrute = 1))
#define Troba1(r1) \
((void) strcpy(exBuf, r1), Troba0())
#define Troba2(r1,r2) \
((void) sprintf(exBuf, r1, r2), Troba0())
#define Troba3(r1,r2,r3) \
((void) sprintf(exBuf, r1, r2, r3), Troba0())
#define Troba4(r1,r2,r3,r4) \
((void) sprintf(exBuf, r1, r2, r3, r4), Troba0())
#define Troba5(r1,r2,r3,r4,r5) \
((void) sprintf(exBuf, r1, r2, r3, r4, r5), Troba0())
#define Xroba0() Exit((exBrute = 2))
#define exit(x) Exit(x)
#define abort() Troba0()
