/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  bitarr.h
*
* Part of: PROD's program probe
*
* Authors: Keijo Heljanko
*
* Current version:
*     $Id: bitarr.h,v 3.1 1997/04/17 15:43:52 kepa Exp $
*
* Description:
*     See bitarr.c.
*
* Version history:
*     $Log: bitarr.h,v $
 * Revision 3.1  1997/04/17  15:43:52  kepa
 * *** empty log message ***
 *
***************************************************************************/

typedef unsigned long ARRAY_ITEM;    /* We could change this one to char if that
					speeds up some machines. */

typedef struct _bit_array
{
    unsigned long numbits;           /* Number of bits stored in this
					bit-array. */
    unsigned long numitems;          /* The number of items used by array. */

    ARRAY_ITEM items[1];             /* This array is actually larger, the
					size of it is numwords. We save one
					pointer indirection in each access
					by doing it this way. */

} BITARRAY;


/* We try to make things portable and hope that
   the compiler will be samrt enough to optimize
   the macros to more efficient ones. */

#define GetBit(array,index) \
( \
    ((ARRAY_ITEM) 0L) != \
    ((ARRAY_ITEM) \
        ( \
            ((ARRAY_ITEM) 1L) & \
            ((ARRAY_ITEM) \
                ( \
                    ( \
                        (array)->items[((unsigned long) (index)) / \
                                       (sizeof(ARRAY_ITEM) * BITSPERBYTE)] \
                    ) >> \
                    ( \
                        ((unsigned long)(index)) % \
                        (sizeof(ARRAY_ITEM) * BITSPERBYTE) \
                    ) \
                ) \
            ) \
        ) \
    ) \
)

#define SetBit(array,index) \
    (((array)->items[((unsigned long)(index)) / \
		     (sizeof(ARRAY_ITEM) * BITSPERBYTE)]) |= \
     (((ARRAY_ITEM)1) << (((unsigned long)(index)) % \
			  (sizeof(ARRAY_ITEM) * BITSPERBYTE)))) \

#define ClearBit(array, index) \
    (((array)->items[((unsigned long)(index)) / \
		     (sizeof(ARRAY_ITEM) * BITSPERBYTE)]) &= \
     ~(((ARRAY_ITEM)1) << (((unsigned long)(index)) % \
			   (sizeof(ARRAY_ITEM) * BITSPERBYTE)))) \

DE1(BITARRAY *, CreateBitArray,
    unsigned long, numbits)
DE1(void, DeleteBitArray,
    BITARRAY *, array)
#ifdef DEBUG
DE2(void, DumpBitArray,
    BITARRAY *, array,
    unsigned, depth)
#endif
DE3(void, BitArrayAnd,
    BITARRAY *, source1,
    BITARRAY *, source2,
    BITARRAY *, dest)
DE3(void, BitArrayOr,
    BITARRAY *, source1,
    BITARRAY *, source2,
    BITARRAY *, dest)
DE2(void, BitArrayNot,
    BITARRAY *, source,
    BITARRAY *, dest)
DE2(void, BitArrayNegateS1OrS2OverwriteS1,
    BITARRAY *, source1,
    BITARRAY *, source2)
