/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  dynamic.h
*
* Part of: PROD's program prpp
*
* Authors: Heikki Suonsivu and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     The macros in this module are used for flexible reading in
*     the sense that whenever a buffer becomes full, the buffer is
*     extended.
*
* Version history:
*     $Log$
***************************************************************************/

#define ADD_BUFFER(c) \
do \
    { \
	if (p >= end) \
	    { \
		register int _i_; \
 \
		size += size; \
		_i_ = (int) (p - buffer); \
		buffer = (char *) Reallocate((char *) buffer, size); \
		end = buffer + size; \
		p = buffer + _i_; \
	    } \
	*p++ = (char) (c); \
    } while (0)

#define BUFFER_DEFINITION(class) \
    class char *buffer = NULL, *end = NULL, *p; \
    class unsigned int size = 0

#define INITIALIZE_BUFFER(bytes) \
p = buffer ? buffer : \
(size = (bytes), buffer = (char *) Allocate(size), end = buffer + size, buffer)

#define DELETE_BUFFER() ClDeallocate(buffer)
