/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  gen2.tpl
*
* Part of: PROD's program prpp
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See gen.tpl.
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include "gen.h"
    
/***************************************************************************
*
* Function:  WhatNew
* Purpose:   This routine produces checks that are made after the setting
*            of some input variable.
* Arguments: checkArcs - the limit checks are limited to these arcs
*            arcContext - FALSE if and only if the produce piece of code
*                         is for a function that is called when the net
*                         is unfolded
* Returns:
* See also:
*
****************************************************************************
*/
FE2(void, WhatNew,
    LIST *, checkArcs,
    BOOL, arcContext)
{
    LSTFOR (TraGGates(transition), gate, SYMBOL)
	{
	    if (SymMarked(gate) || !SymSatisfied(gate))
		continue;
	    SymSet(gate);
	    @+    if (!(
	    PrintSymbol(f, gate);
	    @@))
	    if (arcContext)
		@@        goto _c%a%_%s%;
	    else if (placeLimits)
		{
		    VarSEscape(variable);
		    @@        goto _q%s%;
		}
	    else
		@@        return;
	}
    if (!placeLimits)
	return;
    LSTFOR (checkArcs, arc2, ARC)
	{
	    LSTFOR (ArcGSymsum(arc2), syt2, SYMMULTUP)
		{
		    ylow = NULL;
		    yhigh = NULL;
		    if (PlaGLow(ArcGPlace(arc2)))
			LSTFOR (PlaGLow(ArcGPlace(arc2)), ylow, TUPLE)
			    {
				if (TupGArity(ylow) == SytGArity(syt2))
				    break;
				else if (TupGArity(ylow) > SytGArity(syt2))
				    {
					ylow = NULL;
					break;
				    }
			    }
		    if (PlaGHigh(ArcGPlace(arc2)))
			LSTFOR (PlaGHigh(ArcGPlace(arc2)), yhigh, TUPLE)
			    {
				if (TupGArity(yhigh) == SytGArity(syt2))
				    break;
				else if (TupGArity(yhigh) > SytGArity(syt2))
				    {
					yhigh = NULL;
					break;
				    }
			    }
		    if ((!(csm2 = SytGCffSym(syt2)))
			|| !SymSatisfied(csm2))
			continue;
		    found = FALSE;
		    for (j = 0; j < SytGArity(syt2); j++)
			{
			    if (SymMarked(sym2 = SytGSymbol(syt2, j))
				|| !SymSatisfied(sym2))
				continue;
			    SymSet(sym2);
			    if (SymIsVariable(sym2) &&
				VarHard(var2 = SymGVariable(sym2)))
				{
				    x = VarGLow(var2);
				    if (x < VarGAuxLow(var2))
					x = (DOMAIN) MAXDOMAIN;
				}
			    else
				{
				    var2 = NULL;
				    x = (DOMAIN) MINDOMAIN;
				}
			    if (ylow &&
				((y = TupGField(ylow, j)) > x))
				{
				    if (!found)
					{
					    found = TRUE;
					    @+    if (0L !=
					    @+ (unsigned long) (
					    PrintSymbol(f, csm2);
					    @@))
					    @@        {
					}
                                    @+            if (((DOMAIN) @y@)
				    @+ > (DOMAIN) (
				    PrintSymbol(f, sym2);
				    @@))
				    if (arcContext)
					@@                goto _c%a%_%s%;
				    else
					{
					    VarSEscape(variable);
					    @@                goto _q%s%;
					}
				}
			    if (var2)
				{
				    x = VarGHigh(var2);
				    if (x > VarGAuxHigh(var2))
					x = (DOMAIN) MINDOMAIN;
				}
			    else
				x = (DOMAIN) MAXDOMAIN;
			    if (yhigh &&
				((y = TupGField(yhigh, j)) < x))
				{
				    if (!found)
					{
					    found = TRUE;
					    @+    if (0L !=
					    @+ (unsigned long) (
					    PrintSymbol(f, csm2);
					    @@))
					    @@        {
					}
                                    @+            if (((DOMAIN) @y@)
				    @+ < (DOMAIN) (
				    PrintSymbol(f, sym2);
				    @@))
				    if (arcContext)
					@@                goto _c%a%_%s%;
				    else
					{
					    VarSEscape(variable);
					    @@                goto _q%s%;
					}
				}
			}
		    if (found)
			@@        }
		}
	    LSTFOR (ArcGSymsum(arc2), syt2, SYMMULTUP)
		{
		    if (SytGCffSym(syt2))
			continue;
		    for (j = 0; j < SytGArity(syt2); j++)
			{
			    if (SymMarked(sym2 = SytGSymbol(syt2, j))
				|| !SymSatisfied(sym2))
				continue;
			    SymSet(sym2);
			    if (ylow &&
				((y = TupGField(ylow, j))
				 > (DOMAIN) MINDOMAIN))
				{
                                    @+    if (((DOMAIN) @y@)
				    @+ > (DOMAIN) (
				    PrintSymbol(f, sym2);
				    @@))
				    if (arcContext)
					@@        goto _c%a%_%s%;
				    else
					{
					    VarSEscape(variable);
					    @@        goto _q%s%;
					}
				}
			    if (yhigh &&
				((y = TupGField(yhigh, j))
				 < (DOMAIN) MAXDOMAIN))
				{
                                    @+    if (((DOMAIN) @y@)
				    @+ < (DOMAIN) (
				    PrintSymbol(f, sym2);
				    @@))
				    if (arcContext)
					@@        goto _c%a%_%s%;
				    else
					{
					    VarSEscape(variable);
					    @@        goto _q%s%;
					}
				}
			}
		}
	}
}

/***************************************************************************
*
* Function:  GenFollowers
* Purpose:   Together with ARoutine and FRoutine, this routine produces
*            the computation and firing of enabled transition instances
*            in the case that the net is not unfolded.
* Arguments:
* Returns:
* See also:  ARoutine, FRoutine
*
****************************************************************************
*/
FE0(void, GenFollowers)
{
    @@FE0(void, _ClFollowers)
    @@{
    if (NetGNofClasses(net) != 1)
	{
	    @@    for (_class = 0; _class < %NetGNofClasses(net)%; _class++)
	    @@        {
	    @@            LstDestroy(_bundle[_class], TRUE);
	    @@            LstDestroy(_tmpBundle[_class], TRUE);
	    @@        }
	}
    @@}
    @@
    @@FE0(void, _Followers)
    @@{
#ifdef WEIRD
    if (NetGNofClasses(net) != 1)
	{
	    @@_S_T_A_R_T_: ;
	}
#endif
    @@    ClBlocked();
    if (NetGNofClasses(net) != 1)
	{
	    @@    for (_class = 0; _class < %NetGNofClasses(net)%; _class++)
	    @@        {
	    @@            _bundle[_class] = LstCreate(&peeTools);
	    @@            _tmpBundle[_class] = LstCreate(&peeTools);
	    @@        }
	}
    if (NetGAtoms(net))
	{
	    LSTNUM (NetGTransitions(net), transition, TRANSITION, t)
		if (TraGKind(transition) == TK_INITIAL)
		    break;
	    @+    if (MultupGField(MarFirst(StaGMarking(_state, /*$PlaGName(NetGMonPlace(net))$*/MonPlInd())),
	    @@ (unsigned) 0)
	    @+        == (DOMAIN)
            @@ @MultupGField(MarFirst(PlaGMarking(NetGMonPlace(net))), (unsigned) 0)@)
	    @@        {
	    @@            _F%t%();
	    @@            _someEnb = TRUE;
            @@        }
	    @@    else
	    @@        {
	    @@            _someEnb = FALSE;
	    LSTNUM (NetGTransitions(net), transition, TRANSITION, t)
		{
		    if (TraGKind(transition) == TK_INITIAL)
			continue;
		    if (TraGKind(transition) == TK_DUMMY)
			{
			    if (NetGNofClasses(net) == 1)
				{
				    @@            if (!_someEnb)
				    @@                _F%t%();
				}
			}
		    else
			@@            _F%t%();
		}
	    @@        }
	}
    else
	{
	    LSTNUM (NetGTransitions(net), transition, TRANSITION, t)
		@@    _F%t%();
	}
    if (NetGNofClasses(net) == 1)
	{
	    @@}
	    return;
	}
    @@    for (_class = 0; _class < %NetGNofClasses(net)%; _class++)
    @@        LstDestroy(_tmpBundle[_class], TRUE);
    LSTNUM (NetGPrecedences(net), precedence, PRECEDENCE, p)
	{
	    if ((!PreGSucc(precedence)) || LstEmpty(PreGSucc(precedence))
		|| PreGEasy(precedence) || PreGSelfLoop(precedence))
		continue;
	    @@    LSTFOR (_bundle[%p + 1%], _peer, PEER)
	    @@        {
	    @@            _lwidth = IngGFdProfile(PeeGTrIndex(_peer));
	    @@            _instance = PeeGInstance(_peer);
	    LSTFOR (PreGSucc(precedence), priority, PRECEDENCE)
		{
		    @+            LSTFOR (_bundle[%PreGValue(priority)%],
		    @@ _hpeer, PEER)
		    @+                if (_lwidth ==
		    @@ IngGFdProfile(PeeGTrIndex(_hpeer)))
		    @@                    {
		    @@                        _hfolding = PeeGInstance(_hpeer);
		    @+                        for (_field = 0;
		    @@ _field < _lwidth; _field++)
		    @+                            if (_instance[_field] !=
		    @@ _hfolding[_field])
		    @@                                break;
		    @@                        if (_field == _lwidth)
		    @@                            {
		    @@                                PeeSet(_peer);
		    @@                                break;
		    @@                            }
		    @@                    }
		    if (priority != (PRECEDENCE *)
			LstLast(PreGSucc(precedence)))
			{
			    @@            if (PeeOn(_peer))
			    @@                continue;
			}
		}
	    @@        }
	}
#ifdef WEIRD
    @@    if (_c_o_m_p_a_c_t_)
    @@        {
    @@            _c_o_u_n_t_e_r_ = 0;
    @@            for (_class = 0; _class < %NetGNofClasses(net)%; _class++)
    @@                {
    @@                    LSTFOR (_bundle[_class], _peer, PEER)
    @@                        {
    @@                            if (PeeOn(_peer) ||
    @@                                (((DATATYPE *) NULL) ==
    @@                                 PeeGBuffer(_peer)))
    @@                                continue;
    @@                            _c_o_u_n_t_e_r_++;
    @@                            if (_c_o_u_n_t_e_r_ == 2)
    @@                                break;
    @@                        }
    @@                    if (_c_o_u_n_t_e_r_ == 2)
    @@                        break;
    @@                }
    @@            if (_c_o_u_n_t_e_r_ == 1)
    @@                {
    @@                    for (_class = 0; _class < _magNofPlaces; _class++)
    @@                        MarDiscard(StaGMarking(_state, _class));
    @@                }
    @@            else if ((_c_o_u_n_t_e_r_ == 0) && (_s_e_q_l_e_n_ != 0))
    @@                {
    @@                    _len = StaEncode(_state, EngABuffer(),
    @@                                     EngABufSize());
    @@                    _ndAddr = GphPutNode(_graph[0], EngBuffer(),
    @@                                         _len, &_back);
    @@                    _awAddr = GphPutArrow(_graph[0], _s_e_q_u_e_n_c_e_,
    @@                                          _s_e_q_l_e_n_,
    @@                                          (unsigned long) 0L,
    @@                                          PthEnd(nowPath), _ndAddr,
    @@                                          (unsigned long) -1L,
    @@                                          _back, TRUE);
    @@                    _awFirst = _awAddr;
    @@                    _ndFirst = _ndAddr;
    @@                    _awCount = (unsigned long) 1L;
    @@                }
    @@        }
#endif
    @@    for (_class = 0; _class < %NetGNofClasses(net)%; _class++)
    @@        {
#ifdef WEIRD
    @@            if ((!_c_o_m_p_a_c_t_) && (_kind[_class] != _CL_MEDIUM))
#else
    @@            if (_kind[_class] != _CL_MEDIUM)
#endif
    @@                continue;
    @@            LSTFOR (_bundle[_class], _peer, PEER)
    @@                {
    @@                    if (PeeOn(_peer))
    @@                        continue;
    if (NetGAtoms(net))
	{
	    @@                    _someEnb = TRUE;
	}
    @@                    if (((DATATYPE *) NULL) == PeeGBuffer(_peer))
    @@                        continue;
#ifdef WEIRD
    @@                    if ((!_c_o_m_p_a_c_t_) || (_c_o_u_n_t_e_r_ != 1))
    @@                        _ndAddr = GphPutNode(_graph[0],
    @@                                             PeeGBuffer(_peer),
    @@                                             DataLen(PeeGBuffer(_peer)),
    @@                                             &_back);
    @@                    if (_c_o_m_p_a_c_t_)
    @@                        {
    @@                            if (((DATATYPE *) NULL) == _s_e_q_u_e_n_c_e_)
    @@                                {
    @@                                    _s_e_q_m_a_x_ = 1024;
    @@                                    _s_e_q_u_e_n_c_e_ = (DATATYPE *)
    @@                                        AllocArray(_s_e_q_m_a_x_,
    @@                                                   sizeof(DATATYPE));
    @@                                }
    @@                            _len =
    @@                                InsEncode(PeeGTrIndex(_peer), _class,
    @@                                          PeeGInstance(_peer),
    @@                                          &_s_e_q_u_e_n_c_e_,
    @@                                          &_s_e_q_m_a_x_, _s_e_q_l_e_n_);
    @@                            if (_c_o_u_n_t_e_r_ == 1)
    @@                                {
    @@                                    _s_e_q_l_e_n_ = _len;
    @@                                    StaDecode(PeeGBuffer(_peer), _state);
    @@                                    goto _E_N_D_;
    @@                                }
    @@                            _awAddr = GphPutArrow(_graph[0],
    @@                                                  _s_e_q_u_e_n_c_e_,
    @@                                                  _len, _awCount,
    @@                                                  PthEnd(nowPath),
    @@                                                  _ndAddr, _awFirst,
    @@                                                  _back, TRUE);
    @@                        }
    @@                    else
    @@                        {
    @@                            _len = InsEncode(PeeGTrIndex(_peer), _class,
    @@                                             PeeGInstance(_peer),
    @@                                             EngABuffer(), EngABufSize(),
    @@                                             (unsigned) 0);
    @@                            _awAddr = GphPutArrow(_graph[0], EngBuffer(),
    @@                                                  _len, _awCount,
    @@                                                  PthEnd(nowPath),
    @@                                                  _ndAddr, _awFirst,
    @@                                                  _back, TRUE);
    @@                        }
#else
    @@                    _ndAddr = GphPutNode(_graph[0], PeeGBuffer(_peer),
    @@                                         DataLen(PeeGBuffer(_peer)),
    @@                                         &_back);
    @@                    _len = InsEncode(PeeGTrIndex(_peer), _class,
    @@                                     PeeGInstance(_peer), EngABuffer(),
    @@                                     EngABufSize());
    @@                    _awAddr = GphPutArrow(_graph[0], EngBuffer(), _len,
    @@                                          _awCount, PthEnd(nowPath),
    @+                                          _ndAddr, _awFirst, _back,
    @@ TRUE);
#endif
    @@                    if (Ara())
    @@                        AraStep(PeeVisible(_peer));
    @@                    if ((_awCount == 0L) || FreeExpansion())
    @@                        {
    @@                            _awFirst = _awAddr;
    @@                            _ndFirst = _ndAddr;
    @@                        }
    @@                    _awCount++;
    if (NetGMonPlace(net))
	{
            @@                    if (((unsigned long) -1L) != _back)
            @@                        {
            @@                            if (InfNow())
            @@                                IllInfTrace(TRUE);
            @+                            else if
            @@ (DivNow() && !PeeVisible(_peer))
            @@                                IllDivTrace(TRUE);
            @@                        }
            @@                    else if (Reject() && PeeVisible(_peer))
            @@                        {
            @@                            _folState = StaAlloc();
            @+                            StaDecode
            @@(PeeGBuffer(_peer), _folState);
            @@                            IllTrace();
            @@                            StaDiscard(_folState);
            @@                        }
	}
    @@                }
    @@        }
    if (NetGAtoms(net))
	{
	    LSTNUM (NetGTransitions(net), transition, TRANSITION, t)
		{
		    if (TraGKind(transition) == TK_DUMMY)
			{
			    @@    if (!_someEnb)
			    @@        _F%t%();
			}
		}
	}
#ifdef WEIRD
    @@_E_N_D_: ;
#endif
    @@    for (_class = 0; _class < %NetGNofClasses(net)%; _class++)
    @@        LstDestroy(_bundle[_class], TRUE);
#ifdef WEIRD
    @@    if (_c_o_m_p_a_c_t_)
    @@        {
    @@            if (_c_o_u_n_t_e_r_ == 1)
    @@                goto _S_T_A_R_T_;
    @@            _s_e_q_l_e_n_ = 0;
    @@        }
#endif
    @@}
}

FE0(void, GenAux)
{
    if ((fileCount != 0L) && (nOutpLines < (unsigned long) 800))
	return;
    ClFclose(f);
    (void) sprintf(cName, "%s_%07lx.c", srcPrefix, fileCount);
    prpOutput = MyFopen(cName, "w", (BOOL *) NULL);
    if (!prpOutput)
	{
	    *errStr = '\0';
	    panic(errStr);
	}
    pxFile = f = prpOutput;
    fileCount++;
    nOutpLines = 0L;
    @@##include "_.h"
    @@
}

/***************************************************************************
*
* Function:  Generate
* Purpose:   This routine generates the code corresponding to high level
*            transitions. The _CompInst function is the main routine
*            in unfolding. The _CompPrec function is needed in the unfolding
*            if there are more than one precedence class. The _BuchiOK
*            function returs TRUE if and only if in the considered marking,
*            the atomic subformulas of the specification formula have
*            the truth values mentioned in the label of the considered
*            state of the Buchi automaton. (The Buchi automaton corresponds
*            to the negation of the specification formula.)
* Arguments: genrNet - the input net
* Returns:
* See also:
*
****************************************************************************
*/
FE1(void, Generate,
    NET *, genrNet)
{
    unsigned long fileInd;

    pxFile = f = prpOutput;
    net = genrNet;
    @@
    DefsDecls();
    LSTNUM (NetGTransitions(net), transition, TRANSITION, t)
	{
	    @@DE0(void, _A%t%)/*$TraGName(transition)$*/
	    @@DE0(void, _D%t%)/*$TraGName(transition)$*/
	    @@DE0(void, _E%t%)/*$TraGName(transition)$*/
	    @@DE0(void, _I%t%)/*$TraGName(transition)$*/
	    @@DE0(void, _F%t%)/*$TraGName(transition)$*/
	}
    LSTNUM (NetGPrecedences(net), precedence, PRECEDENCE, p)
	{
	    if ((!PreGSucc(precedence)) || LstEmpty(PreGSucc(precedence)))
		continue;
	    @@DE1(BOOL, _P%p + 1%,
	    @@    TRN *, trn)
	}
    fileCount = 0L;
    GenAux();
    ActualDecls();
    LSTNUM (NetGTransitions(net), transition, TRANSITION, t)
	{
	    dimension = 0;
	    iVarCount = 0;
	    letVarCount = 0;
	    LSTFOR (TraGVariables(transition), variable, VARIABLE)
		{
		    dimension++;
		    if (VarIsIn(variable))
			iVarCount++;
		    if (VarIsLet(variable))
			letVarCount++;
		}
	    if (letVarCount)
		{
		    LSTNUM (TraGVariables(transition), variable, VARIABLE, i)
			if (!VarIsLet(variable))
			    break;
		    letVarCount =
			(letVarCount << 1) | ((i == letVarCount) ? 1 : 0);
		}
	    @@
	    ARoutine();
	    GenAux();
	    @@
	    DRoutine();
	    GenAux();
	    @@
	    ERoutine();
	    GenAux();
	    @@
	    IRoutine();
	    GenAux();
	    cffOrdInputs = LstCreate(&arcTools);
	    LSTFOR (TraGInputs(transition), arc, ARC)
		{
		    cffOrdSymsum = NULL;
		    i = 0;
		    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
			{
			    if (!SytGCffSym(symmultup))
				{
				    if (!cffOrdSymsum)
					cffOrdSymsum = LstCreate(&sytTools);
				    (void) LstInsLast(cffOrdSymsum,
						      (char *) symmultup);
				}
			    else
				i = 1;
			}
		    if (cffOrdSymsum)
			{
			    arc2 = ArcCons(ArcGPlace(arc), cffOrdSymsum);
			    ArcSNumber(arc2, ArcGNumber(arc));
			    ArcSFirst(arc2);
			    if (i == 0)
				ArcSLast(arc2);
			    (void) LstInsLast(cffOrdInputs, (char *) arc2);
			}
		}
	    LSTFOR (TraGInputs(transition), arc, ARC)
		{
		    cffOrdSymsum = NULL;
		    i = 0;
		    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
			{
			    if (SytGCffSym(symmultup))
				{
				    if (!cffOrdSymsum)
					cffOrdSymsum = LstCreate(&sytTools);
				    (void) LstInsLast(cffOrdSymsum,
						      (char *) symmultup);
				}
			    else
				i = 1;
			}
		    if (cffOrdSymsum)
			{
			    arc2 = ArcCons(ArcGPlace(arc), cffOrdSymsum);
			    ArcSNumber(arc2, ArcGNumber(arc));
			    ArcSLast(arc2);
			    if (i == 0)
				ArcSFirst(arc2);
			    (void) LstInsLast(cffOrdInputs, (char *) arc2);
			}
		}
	    found = FALSE;
	    i = 0;
	    LSTFOR (cffOrdInputs, arc, ARC)
		{
		    a = ArcGNumber(arc);
		    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
			{
			    s = SytGNumber(symmultup);
			    if (!found)
				@@
                            @@##define _t%a%_%s% (_t[%i%])
			    i++;
			    found = TRUE;
			}
		}
	    i = 0;
	    LSTFOR (cffOrdInputs, arc, ARC)
		{
		    a = ArcGNumber(arc);
		    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
			{
			    if ((!ArcLast(arc)) ||
				(symmultup != (SYMMULTUP *)
				 LstLast(ArcGSymsum(arc))))
				{
				    s = SytGNumber(symmultup);
                                    @@##define _u%a%_%s% (_u[%i%])
				    i++;
				}
			}
		}
	    @@
	    FRoutine();
	    GenAux();
	    found = FALSE;
	    LSTFOR (cffOrdInputs, arc, ARC)
		{
		    a = ArcGNumber(arc);
		    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
			{
			    s = SytGNumber(symmultup);
			    if (!found)
				@@
                            @@##undef _t%a%_%s%
			    found = TRUE;
			}
		}
	    LSTFOR (cffOrdInputs, arc, ARC)
		{
		    a = ArcGNumber(arc);
		    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
			{
			    if ((!ArcLast(arc)) ||
				(symmultup != (SYMMULTUP *)
				 LstLast(ArcGSymsum(arc))))
				{
				    s = SytGNumber(symmultup);
                                    @@##undef _u%a%_%s%
				}
			}
		}
	    LSTFOR (cffOrdInputs, arc, ARC)
		{
		    LstDestroy(ArcGSymsum(arc), FALSE);
		    Deallocate((char *) arc);
		}
	    LstDestroy(cffOrdInputs, FALSE);
	}
    @@
    GenFollowers();
    GenAux();
    LSTNUM (NetGPrecedences(net), precedence, PRECEDENCE, p)
	{
	    if ((!PreGSucc(precedence)) || LstEmpty(PreGSucc(precedence)))
		continue;
	    @@
	    @@FE1(BOOL, _P%p + 1%,
	    @@    TRN *, trn)
	    @@{
	    @@    SetLowTrn(trn);
	    LSTFOR (PreGSucc(precedence), priority, PRECEDENCE)
		{
		    @+    (void) BalTrApply(TrnBalTree(%PreGValue(priority)%),
		    @@ TrnPrec);
		}
	    @@    return(FALSE);
	    @@}
	    GenAux();
	}
    maxDim = 0;
    LSTFOR (NetGTransitions(net), transition, TRANSITION)
	LSTFOR (TraGArcs(transition), arc, ARC)
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		if (SytGArity(symmultup) > maxDim)
		    maxDim = SytGArity(symmultup);
    @@
    @@FE0(void, _CompInst)
    @@{
    if (newBlock != 0L)
	{
	    @@    unsigned _iBlock;
	    @@
	    @@    if (Blocked() && PtStub() && PtDelAlg())
	    @@        {
            @@            ABlocks((unsigned) %(unsigned) (newBlock + 1L)%);
            @+            for (_iBlock = 0; _iBlock <
            @+ (unsigned) %(unsigned) newBlock%;
	    @@ _iBlock++)
	    @@                SBlock(_iBlock);
	    @@            CBlock(_iBlock);
	    @@        }
	    @@    else
	    @@        ClBlocked();
	}
    else
	@@    ClBlocked();
    @@    _w = TupCons((unsigned) %maxDim%);
    LSTNUM (NetGTransitions(net), transition, TRANSITION, t)
	@@    _I%t%();
    @@    TupSArity(_w, (unsigned) %maxDim%);
    @@    TupDiscard(_w);
    @@}
    GenAux();
    @@
    @@FE0(void, _CompPrec)
    @@{
    LSTNUM (NetGPrecedences(net), precedence, PRECEDENCE, p)
	{
	    if ((!PreGSucc(precedence)) || LstEmpty(PreGSucc(precedence)))
		continue;
	    @@    (void) BalTrApply(TrnBalTree(%p + 1%), _P%p + 1%);
	}
    @@}
    @@
    @@FE0(BOOL, _BuchiOK)
    @@{
    if (NetGAtoms(net))
	{
	    @+    _i_ = (unsigned) (MultupGField
	    @@(MarFirst(StaGMarking(_evalState, /*$PlaGName(NetGMonPlace(net))$*/MonPlInd())),
	    @@                                (unsigned) 0) - 1);
	    pxGotoNumber = 0L;
	    for (atom = (FORMULA *) LstBegin(NetGAtoms(net)), mask = 2L; atom;
		 atom = (FORMULA *) LstStep(NetGAtoms(net)), mask <<= 2)
		{
                    @@    if ((_z_[_i_] & (unsigned long) #mask#) != 0L) {
		    @@        _xprTuple = NULL;
		    XprOut(atom->uf.expression, 0);
                    @+    if (((_z_[_i_] & (unsigned long) #mask >> 1#) == 0L)
		    @@ != (_xprDom == (DOMAIN) 0L))
		    @@        return(FALSE);
		    @@    }
		}
	}
    @@    return(TRUE);
    @@}
    if (prpOutput == f)
        prpOutput = (FILE *) NULL;
    ClFclose(f);
#ifdef UNIX
    (void) sprintf(cName, "%s_.sh", srcPrefix);
    f = MyFopen(cName, "w", (BOOL *) NULL);
    if (!f)
	{
	    *errStr = '\0';
	    panic(errStr);
	}
    for (fileInd = 0L; fileInd < fileCount; fileInd++)
	(void)
	    fprintf(f,
		    "\"${COMPILA}\" \"${COMPILB}\" _%07lx.c || exit\n${%s} \"${LIBRARY}\" _%07lx${O} || exit\n${DELETE} _%07lx${O} || exit\n",
		    fileInd, (0L == fileInd) ? "LIBFIRST" : "LIBNEXT",
		    fileInd, fileInd);
#else
    (void) sprintf(cName, "%s__.bat", srcPrefix);
    f = MyFopen(cName, "w", (BOOL *) NULL);
    if (!f)
	{
	    *errStr = '\0';
	    panic(errStr);
	}
    (void) fputs("@echo on\n@if errorlevel 1 clerr.exe\n", f);
    for (fileInd = 0L; fileInd < fileCount; fileInd++)
	{
            (void) fprintf(f, "call .%c_.bat _%07lx.c\n", DIRCHAR, fileInd);
	    if (fileInd + 1L != fileCount)
		(void) fputs("@if errorlevel 1 goto end\n", f);
	}
    if (1L < fileCount)
	(void) fputs(":end\n", f);
    ClFclose(f);
    (void) sprintf(cName, "%s_.rsp", srcPrefix);
    f = MyFopen(cName, "w", (BOOL *) NULL);
    if (!f)
	{
	    *errStr = '\0';
	    panic(errStr);
	}
    for (fileInd = 0L; fileInd < fileCount; fileInd++)
	if (fileInd + 1L == fileCount)
	    (void) fprintf(f, "+_%07lx.obj;\n", fileInd);
	else
	    (void) fprintf(f, "+_%07lx.obj &\n", fileInd);
    ClFclose(f);
    (void) sprintf(cName, "%s_.r32", srcPrefix);
    f = MyFopen(cName, "w", (BOOL *) NULL);
    if (!f)
	{
	    *errStr = '\0';
	    panic(errStr);
	}
    for (fileInd = 0L; fileInd < fileCount; fileInd++)
	(void) fprintf(f, "_%07lx.obj\n", fileInd);
#endif
    ClFclose(f);
}
