/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  gen3.tpl
*
* Part of: PROD's program prpp
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See gen.tpl.
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include "gen.h"

/***************************************************************************
*
* Function:  IRoutine
* Purpose:   Together with DRoutine and ERoutine, this routine produces
*            the unfolding of a high level transition.
* Arguments:
* Returns:
* See also:  DRoutine, ERoutine, FRoutine
*
****************************************************************************
*/
FE0(void, IRoutine)
{
    @@FE0(void, _I%t%)/*$TraGName(transition)$*/
    @@{
    WhatInitial(TraGArcs(transition));
    if (letVarCount)
        {
            @+    TravRange((unsigned) %t%, (unsigned) %letVarCount >> 1%,
            if (letVarCount & 1)
                @+ _v
            else
                @+ TupGArray(_w)
            @@, _E%t%);
        }
    else
        {
            cffOrdVariables = LstCreate(&varTools);
            LSTFOR (TraGVariables(transition), variable, VARIABLE)
            if (VarIsIn(variable) && (!VarUgly(variable)) &&
                VarGName(variable))
                (void) LstInsLast(cffOrdVariables, (char *) variable);
            LSTFOR (TraGVariables(transition), variable, VARIABLE)
                if (VarIsIn(variable) && VarUgly(variable) &&
                    VarGName(variable))
                (void) LstInsLast(cffOrdVariables, (char *) variable);
            LSTROLL (cffOrdVariables, variable, VARIABLE, s)
                {
                    @+    $VarGLabel(variable)$ =
                    @@ (DOMAIN) @VarGLow(variable)@;
                    VarSet(variable);
                    VarCEscape(variable);
                    @@_p%s%: ;
                    WhatNew(TraGArcs(transition), FALSE);
                }
            @@    _E%t%();
            LSTUNROLL (cffOrdVariables, variable, VARIABLE, s)
                {
                    if (VarEscape(variable))
                        @@_q%s%: ;
                    @+    if ($VarGLabel(variable)$ !=
                    @@ (DOMAIN) @VarGHigh(variable)@)
                    @@        {
                    @@            $VarGLabel(variable)$++;
                    @@            goto _p%s%;
                    @@        }
                }
            LstDestroy(cffOrdVariables, FALSE);
        }
    @@}
}

/***************************************************************************
*
* Function:  FRoutine
* Purpose:   Together with ARoutine, this routine produces the computation
*            (and possible firing) of enabled instances of a high level
*            transition in the case that the net is not unfolded.
* Arguments:
* Returns:
* See also:  ARoutine, IRoutine
*
****************************************************************************
*/
FE0(void, FRoutine)
{
    @@FE0(void, _F%t%)/*$TraGName(transition)$*/
    @@{
    WhatInitial(TraGOutputs(transition));
    LSTFOR (TraGInputs(transition), arc, ARC)
	{
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		if (!SytGCffSym(symmultup))
		    break;
	    if (symmultup)
		{
		    p = LstWhich(NetGPlaces(net),
				 (char *) ArcGPlace(arc)) - 1;
                    @+    if (MarEmpty(StaGMarking(_state,
                    @@ (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%)))
		    @@        return;
		}
	}
    LSTFOR (TraGVariables(transition), variable, VARIABLE)
	{
	    if ((!VarIsIn(variable)) || (!VarHard(variable)))
		continue;
	    VarSLow(variable, (DOMAIN) MINDOMAIN);
	    VarSHigh(variable, (DOMAIN) MAXDOMAIN);
	    VarSAuxLow(variable, (DOMAIN) MINDOMAIN);
	    VarSAuxHigh(variable, (DOMAIN) MAXDOMAIN);
	}
    LSTFOR (TraGInputs(transition), arc, ARC)
	LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
	    {
		xlow = NULL;
		xhigh = NULL;
		if (PlaGLow(ArcGPlace(arc)))
		    LSTFOR (PlaGLow(ArcGPlace(arc)), xlow, TUPLE)
			{
			    if (TupGArity(xlow) == SytGArity(symmultup))
				break;
			    else if (TupGArity(xlow) > SytGArity(symmultup))
				{
				    xlow = NULL;
				    break;
				}
			}
		if (PlaGHigh(ArcGPlace(arc)))
		    LSTFOR (PlaGHigh(ArcGPlace(arc)), xhigh, TUPLE)
			{
			    if (TupGArity(xhigh) == SytGArity(symmultup))
				break;
			    else if (TupGArity(xhigh) > SytGArity(symmultup))
				{
				    xhigh = NULL;
				    break;
				}
			}
		if (!SytGCffSym(symmultup))
		    for (i = 0; i < SytGArity(symmultup); i++)
			if (SymIsVariable(symbol =
					  SytGSymbol(symmultup, i)))
			    {
				variable = SymGVariable(symbol);
				if (xlow &&
				    ((x = TupGField(xlow, i))
				     > VarGAuxLow(variable)))
				    VarSAuxLow(variable, x);
				if (xhigh &&
				    ((x = TupGField(xhigh, i))
				     < VarGAuxHigh(variable)))
				    VarSAuxHigh(variable, x);
			    }
	    }
    LSTFOR (TraGOutputs(transition), arc, ARC)
	LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
	    {
		xlow = NULL;
		xhigh = NULL;
		if (PlaGLow(ArcGPlace(arc)))
		    LSTFOR (PlaGLow(ArcGPlace(arc)), xlow, TUPLE)
			{
			    if (TupGArity(xlow) == SytGArity(symmultup))
				break;
			    else if (TupGArity(xlow) > SytGArity(symmultup))
				{
				    xlow = NULL;
				    break;
				}
			}
		if (PlaGHigh(ArcGPlace(arc)))
		    LSTFOR (PlaGHigh(ArcGPlace(arc)), xhigh, TUPLE)
			{
			    if (TupGArity(xhigh) == SytGArity(symmultup))
				break;
			    else if (TupGArity(xhigh) > SytGArity(symmultup))
				{
				    xhigh = NULL;
				    break;
				}
			}
		for (i = 0; i < SytGArity(symmultup); i++)
		    if (SymIsVariable(symbol =
				      SytGSymbol(symmultup, i)) &&
			VarIsIn(variable = SymGVariable(symbol)))
			{
			    if (SytGCffSym(symmultup))
				{
				    VarSAuxLow(variable, (DOMAIN) MINDOMAIN);
				    VarSAuxHigh(variable, (DOMAIN) MAXDOMAIN);
				}
			    else
				{
				    if (xlow &&
					((x = TupGField(xlow, i))
					 > VarGLow(variable)))
					VarSLow(variable, x);
				    if (xhigh &&
					((x = TupGField(xhigh, i))
					 < VarGHigh(variable)))
					VarSHigh(variable, x);
				}
			}
	    }
    LSTROLL (cffOrdInputs, arc, ARC, ca)
	{
	    a = ArcGNumber(arc);
	    p = LstWhich(NetGPlaces(net), (char *) ArcGPlace(arc)) - 1;
	    @@    _marking = StaGMarking(_state, (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%);
	    if (ArcFirst(arc))
		{
		    s = SytGNumber((SYMMULTUP *) LstFirst(ArcGSymsum(arc)));
		    ls = SytGLabel((SYMMULTUP *) LstFirst(ArcGSymsum(arc)));
		    @@    MARFOR (_marking, $ls$_t%a%_%s%)
		    @@        MultupSFreeCount($ls$_t%a%_%s%, MultupGCount($ls$_t%a%_%s%));
		}
	    LstStart(ArcGSymsum(arc));
	    LstStore(ArcGSymsum(arc));
	    symmultup = (SYMMULTUP *) LstStep(ArcGSymsum(arc));
	    cs = 0;
	    while (symmultup)
		{
		    s = SytGNumber(symmultup);
		    ls = SytGLabel(symmultup);
		    if (SytGCffSym(symmultup))
			{
                            @+    if (0L == (unsigned long) (
                            PrintSymbol(f, SytGCffSym(symmultup));
                            @@))
			    @@        goto _e%a%_%s%;
                        }
                    @@    $ls$_t%a%_%s% = MarBegin(_marking);
                    if (SytGArity(symmultup))
                        {
                            @+    while ($ls$_t%a%_%s% &&
                            @+ (MultupGArity($ls$_t%a%_%s%) < (unsigned)
                            @@ %SytGArity(symmultup)%))
                            @@        $ls$_t%a%_%s% = MarStep(_marking);
                        }
                    @+    if ((!$ls$_t%a%_%s%) ||
                    @+ (MultupGArity($ls$_t%a%_%s%) > (unsigned)
                    @@ %SytGArity(symmultup)%))
                    @@        goto _d%a%_%s%;
                    @@_b%a%_%s%: ;
                    @+    if (MultupGFreeCount($ls$_t%a%_%s%)
                    @+ < (unsigned long)
                    if (SytGCffSym(symmultup))
                        {
                            @+ (
                            PrintSymbol(f, SytGCffSym(symmultup));
                            @+)
                        }
                    else
                        @+ #SytGMulti(symmultup)#
                    @@)
		    @@        goto _c%a%_%s%;
	            for (i = 0; i < SytGArity(symmultup); i++)
			{
			    symbol = SytGSymbol(symmultup, i);
			    if (!SymSatisfied(symbol))
				continue;
			    SymSet(symbol);
			    @+    if (MultupGField($ls$_t%a%_%s%, (unsigned) %i%) != (DOMAIN) (
			    PrintSymbol(f, symbol);
			    @@))
			    @@        goto _c%a%_%s%;
			}
	            for (i = 0; i < SytGArity(symmultup); i++)
			{
			    symbol = SytGSymbol(symmultup, i);
			    if (!SymIsVariable(symbol))
				continue;
			    variable = SymGVariable(symbol);
			    if (VarUnified(variable))
				continue;
			    VarSet(variable);
			    SymSet(symbol);
			    @+    $VarGLabel(variable)$
			    @@ = MultupGField($ls$_t%a%_%s%, (unsigned) %i%);
			    if (VarHard(variable))
				{
				    if (VarGLow(variable) >
					VarGAuxLow(variable))
					{
					    @+    if ($VarGLabel(variable)$ <
                                            @@ (DOMAIN) @VarGLow(variable)@)
				            @@        goto _c%a%_%s%;
					}
				    if (VarGHigh(variable) <
					VarGAuxHigh(variable))
					{
					    @+    if ($VarGLabel(variable)$ >
                                            @@ (DOMAIN) @VarGHigh(variable)@)
				            @@        goto _c%a%_%s%;
					}
				}
			    acursor = LstGet(cffOrdInputs);
			    arc2 = (ARC *) LstBegin(cffOrdInputs);
			    ca2 = 0;
			    while (ca2 <= ca)
				{
				    a2 = ArcGNumber(arc2);
				    scursor = LstGet(ArcGSymsum(arc2));
				    syt2 = (SYMMULTUP *)
					LstBegin(ArcGSymsum(arc2));
				    cs2 = 0;
				    while (syt2 &&
					   ((ca2 != ca) || (cs2 <= cs)))
					{
					    s2 = SytGNumber(syt2);
					    ls2 = SytGLabel(syt2);
					    for (j = 0; j < SytGArity(syt2);
						 j++)
						{
						    symbol =
							SytGSymbol(syt2, j);
						    if (SymMarked(symbol) ||
							!SymSatisfied(symbol))
							continue;
						    SymSet(symbol);
						    @+    if (MultupGField
						    @+($ls2$_t%a2%_%s2%, (unsigned) %j%)
						    @+ != (DOMAIN) (
						    PrintSymbol(f, symbol);
						    @@))
						    @@        goto _c%a%_%s%;
						}
					    syt2 = (SYMMULTUP *)
						LstStep(ArcGSymsum(arc2));
					    cs2++;
					}
				    LstSet(ArcGSymsum(arc2), scursor);
				    arc2 = (ARC *)
					LstStep(cffOrdInputs);
				    ca2++;
				}
			    LstSet(cffOrdInputs, acursor);
			    WhatNew(TraGOutputs(transition), TRUE);
			}
                    if (SytGCffSym(symmultup))
			{
			    @+    MultupDFreeCount($ls$_t%a%_%s%, (unsigned long) (
                            PrintSymbol(f, SytGCffSym(symmultup));
                            @@));
			}
	            else
			{
			    @+    MultupDFreeCount($ls$_t%a%_%s%, (unsigned long)
                            @@ #SytGMulti(symmultup)#);
			}
		    if ((!ArcLast(arc)) ||
			(symmultup != (SYMMULTUP *) LstLast(ArcGSymsum(arc))))
			@@    _u%a%_%s% = MarGet(_marking);
                    if (SytGCffSym(symmultup))
                        @@_e%a%_%s%: ;
		    LstStore(ArcGSymsum(arc));
	            symmultup = (SYMMULTUP *) LstStep(ArcGSymsum(arc));
	            cs++;
	        }
	}
    LSTFOR (TraGVariables(transition), variable, VARIABLE)
	if (VarUgly(variable) || !VarIsIn(variable))
	    VarReset(variable);
    LSTFOR (TraGOutputs(transition), arc2, ARC)
	LSTFOR (ArcGSymsum(arc2), syt2, SYMMULTUP)
	    for (j = 0; j < SytGArity(syt2); j++)
		if (!SymSatisfied(sym2 = SytGSymbol(syt2, j)))
		    SymReset(sym2);
    LSTFOR (TraGGates(transition), gate, SYMBOL)
	if (!SymSatisfied(gate))
	    SymReset(gate);
    LSTROLL (TraGVariables(transition), variable, VARIABLE, s)
	{
	    if ((!VarUgly(variable)) || (!VarIsIn(variable)))
		continue;
	    LSTFOR (VarGCoeffs(variable), cffSym, SYMBOL)
		{
		    @+    if (0L != (unsigned long) (
                    PrintSymbol(f, cffSym);
                    @@))
                    @@        goto _r%s%;
		}
            @@    $VarGLabel(variable)$ = (DOMAIN) @VarGLow(variable)@;
	    VarSet(variable);
	    VarCEscape(variable);
            @@_p%s%: ;
	    WhatNew(TraGOutputs(transition), FALSE);
	    if (!LstEmpty(VarGCoeffs(variable)))
		@@_r%s%: ;
	}
    if (letVarCount)
        {
            if (!(letVarCount & 1))
                {
                    i = 0;
                    LSTFOR (TraGVariables(transition), variable, VARIABLE)
                        if (VarIsLet(variable))
                            {
                                @+    TupSField(_w, (unsigned) %i%,
                                @@ $VarGLabel(variable)$);
                                i++;
                            }
                }
            @+    if (!InRange((unsigned) %t%, (unsigned) %letVarCount >> 1%,
            if (letVarCount & 1)
                @@ _v,
            else
                @@ TupGArray(_w),
            @@                 EngABuffer(), EngABufSize()))
            @@        goto _CONT;
        }
    if (NetGNofClasses(net) != 1)
	@@    _class = 0;
    else if (TraGComputation(transition))
	@@    _list = LstCreate(&peeTools);
    if (!NetGMonPlace(net))
	@@    _visible = PtDefVis() ? 1 : 0;
    else if (NetGAtoms(net))
	{
	    @+    for (_y_ = _x_[
	    if (TraGKind(transition) == TK_INITIAL)
                @+%((unsigned) MultupGField(MarFirst(PlaGMarking(NetGMonPlace(net))), (unsigned) 0)) - 1%
	    else
		@+((unsigned) $VarGLabel((VARIABLE *) LstNth(TraGVariables(transition), LstSize(TraGVariables(transition)) - 1))$) - 1
	    @@]; ($VarGLabel((VARIABLE *) LstLast(TraGVariables(transition)))$ = *_y_); _y_++)
	}
    if (!TraGComputation(transition))
	@@    _A%t%();
    else
	{
	    if (NetGNofClasses(net) != 1)
                @@##define Precedence(class) (_class = (class))
	    if (!NetGMonPlace(net))
		{
                    @@##define Visible() (_visible = 1)
                    @@##define Invisible() (_visible = 0)
		}
            @@##define Accept() _A%t%()
	    @+    {
	    LSTFOR (TraGComputation(transition), str, char)
		@+$str$
	    @@}
	    if (NetGNofClasses(net) != 1)
                @@##undef Precedence
	    if (!NetGMonPlace(net))
		{
                    @@##undef Visible
                    @@##undef Invisible
		}
            @@##undef Accept
	    if (NetGNofClasses(net) != 1)
		{
		    @+    for
                    @@ (_class = 0; _class < %NetGNofClasses(net)%; _class++)
		    @@        {
		    @@            if (LstEmpty(_tmpBundle[_class]))
		    @@                continue;
#ifdef WEIRD
		    @@            if ((!_c_o_m_p_a_c_t_) && (_kind[_class] == _CL_INDEPENDENT))
#else
		    @@            if (_kind[_class] == _CL_INDEPENDENT)
#endif
	            @@                {
	            @+                    LstDestroy
	            @@(_tmpBundle[_class], TRUE);
	            @+                    _tmpBundle[_class] =
	            @@ LstCreate(&peeTools);
	            @@                }
	            @@            else
	            @+                (void) LstCatenate
	            @@(_bundle[_class], _tmpBundle[_class]);
	            @@        }
		}
	    else
		@@    LstDestroy(_list, TRUE);
	}
    if (letVarCount)
        @@_CONT: ;
    LSTUNROLL (TraGVariables(transition), variable, VARIABLE, s)
	{
	    if ((!VarUgly(variable)) || (!VarIsIn(variable)))
		continue;
	    LSTFOR (VarGCoeffs(variable), cffSym, SYMBOL)
		{
		    @+    if (0L != (unsigned long) (
                    PrintSymbol(f, cffSym);
                    @@))
                    @@        goto _s%s%;
		}
	    if (VarEscape(variable))
		@@_q%s%: ;
            @@    if ($VarGLabel(variable)$ != (DOMAIN) @VarGHigh(variable)@)
            @@        {
            @@            $VarGLabel(variable)$++;
            @@            goto _p%s%;
            @@        }
	    if (!LstEmpty(VarGCoeffs(variable)))
		@@_s%s%: ;
	}
    LSTUNNEST (cffOrdInputs, arc, ARC)
	{
	    a = ArcGNumber(arc);
	    p = LstWhich(NetGPlaces(net), (char *) ArcGPlace(arc)) - 1;
	    @@    _marking = StaGMarking(_state, (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%);
	    LSTUNNEST (ArcGSymsum(arc), symmultup, SYMMULTUP)
		{
		    s = SytGNumber(symmultup);
		    ls = SytGLabel(symmultup);
                    if (SytGCffSym(symmultup))
			{
                            @+    if (0L == (unsigned long) (
                            PrintSymbol(f, SytGCffSym(symmultup));
                            @@))
			    @@        goto _d%a%_%s%;
			}
		    if ((!ArcLast(arc)) ||
			(symmultup != (SYMMULTUP *) LstLast(ArcGSymsum(arc))))
			@@    MarSet(_marking, _u%a%_%s%);
                    if (SytGCffSym(symmultup))
			{
			    @+    MultupIFreeCount($ls$_t%a%_%s%, (unsigned long) (
                            PrintSymbol(f, SytGCffSym(symmultup));
                            @@));
			}
	            else
			{
			    @+    MultupIFreeCount($ls$_t%a%_%s%, (unsigned long)
                            @@ #SytGMulti(symmultup)#);
			}
		    @@_c%a%_%s%: ;
                    @@    if (($ls$_t%a%_%s% = MarStep(_marking)) &&
                    @+        (MultupGArity($ls$_t%a%_%s%) == (unsigned)
                    @@ %SytGArity(symmultup)%))
		    @@        goto _b%a%_%s%;
                    @@_d%a%_%s%: ;
		}
	}
    @@}
}
