/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  gen4.tpl
*
* Part of: PROD's program prpp
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See gen.tpl.
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include "gen.h"

/***************************************************************************
*
* Function:  ARoutine
* Purpose:   This routine produces the actions performed in Accept() in the
*            case that the net is not unfolded.
* Arguments:
* Returns:
* See also:  DRoutine, FRoutine
*
****************************************************************************
*/
FE0(void, ARoutine)
{
    @@FE0(void, _A%t%)/*$TraGName(transition)$*/
    @@{
    ADLimits(TRUE);
    if (NetGAtoms(net))
	@@    _visible = 1;
    if (TraGComputation(transition))
	{
	    if (NetGNofClasses(net) != 1)
		@@    _list = _tmpBundle[_class];
	    if (dimension == iVarCount)
		{
		    @@    if (!LstEmpty(_list))
		    @@        return;
		    @@    LstSet(_list, (VOID *) NULL);
		}
	    else
		{
		    @@    _cursor = NULL;
		    @@    LSTFOR (_list, _peer, PEER)
		    @@        {
		    @@            _instance = PeeGInstance(_peer);
		    LSTNUM (TraGVariables(transition), variable,
			    VARIABLE, i)
			{
                            if (VarIsIn(variable))
				continue;
			    @+            if (_instance[%i%] >
			    @@ $VarGLabel(variable)$)
			    @@                break;
			    @+            if (_instance[%i%] <
			    @@ $VarGLabel(variable)$)
			    @@                {
			    @@                    _cursor = LstGet(_list);
			    @@                    continue;
			    @@                }
			}
		    @@            return;
		    @@        }
		    @@    LstSet(_list, _cursor);
		}
	}
    if (NetGNofClasses(net) != 1)
	{
	    @@    if (_kind[_class] == _CL_INHIBITOR)
	    @@        goto C_O_N_T;
	}
    @@    _folState = StaFrCopy(_state);
    LSTFOR (TraGOutputs(transition), arc, ARC)
	{
	    if (LstEmpty(ArcGSymsum(arc)))
		continue;
	    p = LstWhich(NetGPlaces(net), (char *)
			 ArcGPlace(arc)) - 1;
	    @@    _marking = StaGMarking(_folState, (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%);
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		{
		    if (SytGCffSym(symmultup))
			{
			    @+    if (0L != (unsigned long) (
			    PrintSymbol(f, SytGCffSym(symmultup));
			    @@))
			    @@        {
		            @+            _tuple =
                            @@ TupCons((unsigned) %SytGArity(symmultup)%);
			    for (i = 0; i < SytGArity(symmultup); i++)
				{
				    @+            TupSField(_tuple,
                                    @+ (unsigned) %i%, (DOMAIN) (
				    PrintSymbol(f, SytGSymbol(symmultup, i));
				    @@));
				}
			    @+            MarInsert(_marking,
			    @+ MultupCons((unsigned long) (
			    PrintSymbol(f, SytGCffSym(symmultup));
			    @@), _tuple));
			    @@        }
			}
		    else
			{
		            @+    _tuple =
                            @@ TupCons((unsigned) %SytGArity(symmultup)%);
			    for (i = 0; i < SytGArity(symmultup); i++)
				{
				    @+    TupSField(_tuple,
                                    @+ (unsigned) %i%, (DOMAIN) (
				    PrintSymbol(f, SytGSymbol(symmultup, i));
				    @@));
				}
			    @+    MarInsert(_marking,
                            @+ MultupCons((unsigned long)
                            @@ #SytGMulti(symmultup)#, _tuple));
			}
		}
	}
    if (NetGAtoms(net))
	{
	    if (TraGKind(transition) == TK_NORM)
		{
		    if (NetGNofClasses(net) != 1)
			{
			    @@    if (_kind[_class] != _CL_MEDIUM)
			    @@        _someEnb = TRUE;
			}
		    else
			{
			    @@    _someEnb = TRUE;
			}
		}
	    @@    _evalState = _folState;
	    @@    if (!((*_buchiOK)()))
	    @@        {
	    @@            StaDiscard(_folState);
	    if (NetGNofClasses(net) != 1)
		{
		    @@            goto C_O_N_T;
		}
	    else
		{
		    @@            return;
		}
	    @@        }
	}
    if (NetGNofClasses(net) != 1)
	{
#ifdef WEIRD
	    @@    if (_c_o_m_p_a_c_t_ || (_kind[_class] == _CL_MEDIUM))
#else
	    @@    if (_kind[_class] == _CL_MEDIUM)
#endif
	    @@        {
	    @+            (void) StaEncode(_folState, EngABuffer(),
	    @@ EngABufSize());
	    @@            StaDiscard(_folState);
	    if (!TraGComputation(transition))
		{
		    @+            (void) LstInsLast(_bundle[_class]
		}
            else
		{
		    @+            (void) LstInsNext(_list
		}
            @@, (char *)
            @+                              PeeCons((unsigned) %t%,
            if (LstEmpty(TraGVariables(transition)))
		{
		    @+ (DOMAIN *) NULL
		}
            else
		{
		    @+ _v
		}
	    @@, EngBuffer(), _visible));
            @@            return;
            @@        }
	}
    @@    _len = StaEncode(_folState, EngABuffer(), EngABufSize());
    @@    _ndAddr = GphPutNode(_graph[0], EngBuffer(), _len, &_back);
    @+    _len = InsEncode((unsigned) %t%,
    if (NetGNofClasses(net) != 1)
        @+ _class,
    else
	@+ (unsigned) 0,
    if (LstEmpty(TraGVariables(transition)))
        @+ (DOMAIN *) NULL
    else
        @+ _v
    @+, EngABuffer(), EngABufSize()
#ifdef WEIRD
    @+, (unsigned) 0
#endif
    @@);
    @@    _awAddr = GphPutArrow(_graph[0], EngBuffer(), _len,
    @@                          _awCount, PthEnd(nowPath), _ndAddr,
    @+                          _awFirst, _back,
    if (NetGMonPlace(net))
	@+ !_visible
    else
	@+ TRUE
    @@);
    @@    if (Ara())
    @@        AraStep(_visible);
    @@    if ((_awCount == 0L) || FreeExpansion())
    @@        {
    @@            _awFirst = _awAddr;
    @@            _ndFirst = _ndAddr;
    @@        }
    @@    _awCount++;
    if (NetGMonPlace(net))
	{
	    @@    if (((unsigned long) -1L) != _back)
            @@        {
            @@            if (InfNow())
            @@                IllInfTrace(TRUE);
	    @@            else if (DivNow() && !_visible)
            @@                IllDivTrace(TRUE);
	    @@        }
	    @@    else if (Reject() && _visible)
	    @@        IllTrace();
	}
    @@    StaDiscard(_folState);
    if (NetGNofClasses(net) != 1)
	{
	    @@C_O_N_T: ;
	}
    if ((NetGNofClasses(net) != 1) && !TraGComputation(transition))
	{
	    @@    if (_kind[_class] == _CL_INDEPENDENT)
	    @@        return;
	    @+    (void) LstInsLast(_bundle[_class]
	}
    else if (TraGComputation(transition))
	{
	    @+    (void) LstInsNext(_list
	}
    if ((NetGNofClasses(net) != 1) || TraGComputation(transition))
	{
            @@, (char *)
            @+                      PeeCons((unsigned) %t%,
            if (LstEmpty(TraGVariables(transition)))
                @+ (DOMAIN *) NULL
	    else
	        @+ _v
            @@, (DATATYPE *) NULL, _visible));
        }
    @@}
}

/***************************************************************************
*
* Function:  DRoutine
* Purpose:   This routine produces the actions performed in Accept()
*            in the case that the net is unfolded.
* Arguments:
* Returns:
* See also:  ARoutine, ERoutine, IRoutine
*
****************************************************************************
*/
FE0(void, DRoutine)
{
    unsigned long *numBlock;

    @@FE0(void, _D%t%)/*$TraGName(transition)$*/
    @@{
    ADLimits(FALSE);
    @+    (void) InsEncode((unsigned) %t%,
    if (NetGNofClasses(net) != 1)
	@+ _class,
    else
        @+ (unsigned) 0,
    if (LstEmpty(TraGVariables(transition)))
        @+ (DOMAIN *) NULL
    else
	@+ _v
    @+, EngABuffer(), EngABufSize()
#ifdef WEIRD
    @+, (unsigned) 0
#endif
    @@);
    @+    _trn = GetTrn(
    if (NetGNofClasses(net) != 1)
	@+ _class,
    else
        @+ (unsigned) 0,
    @@ EngBuffer(), &_novelty);
    @@    if (!_novelty)
    @@        return;
    if (NetGAtoms(net))
	{
	    if (TraGKind(transition) == TK_DUMMY)
		@@    TrnSDummy(_trn);
	    else if (TraGKind(transition) == TK_INITIAL)
		@@    TrnSInitial(_trn);
            else if (!LstEmpty(TraGBlocks(transition)))
                {
                    @@    TrnSVisible(_trn);
                    @@    if (Blocked())
                    @@        {
                    @+            TrnABlocks(_trn, (unsigned)
                    @@ %LstSize(TraGBlocks(transition)) + 1%);
                    LSTNUM (TraGBlocks(transition), numBlock,
                            unsigned long, i)
                        {
                            @+            (void) LstInsLast(Block((unsigned)
                            @@ %(unsigned) *numBlock%), (char *) _trn);
                            @+            TrnSBlock(_trn, (unsigned) %i%,
                            @@ (unsigned) %(unsigned) *numBlock%);
                        }
                    @+            TrnSBlock(_trn, (unsigned) %i%,
                    @@ (unsigned) -1);
                    @@        }
                }
	}
    else
	{
	    @@    if (_visible)
	    @@        TrnSVisible(_trn);
	}
    LSTFOR (TraGInputs(transition), arc, ARC)
	{
	    if (LstEmpty(ArcGSymsum(arc)) ||
		(NetGAtoms(net) && (ArcGPlace(arc) == NetGMonPlace(net))))
		continue;
	    p = LstWhich(NetGPlaces(net), (char *) ArcGPlace(arc)) - 1;
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		{
		    if (SytGCffSym(symmultup))
			{
			    @+    if (0L != (unsigned long) (
		            PrintSymbol(f, SytGCffSym(symmultup));
		            @@))
		            @@        {
			    @+            TupSArity(_w, (unsigned)
			    @@ %SytGArity(symmultup)%);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            @+            TupSField(_w, (unsigned) %i%,
			            if (SymIsVariable(symbol))
				        @+ $VarGLabel(SymGVariable(symbol))$
			            else
				       {
					   @+ (DOMAIN) (
	                                   PrintSymbol(f, symbol);
				           @+)
				       }
				    @@);
				}
		            @+            PutInArc(_trn, (unsigned long) (
		            PrintSymbol(f, SytGCffSym(symmultup));
                            @@), (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%, _w);
		            @@        }
			}
		    else
			{
			    @+    TupSArity(_w, (unsigned)
			    @@ %SytGArity(symmultup)%);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            @+    TupSField(_w, (unsigned) %i%,
			            if (SymIsVariable(symbol))
				        @+ $VarGLabel(SymGVariable(symbol))$
			            else
				       {
					   @+ (DOMAIN) (
	                                   PrintSymbol(f, symbol);
				           @+)
				       }
				    @@);
				}
		            @+    PutInArc(_trn, (unsigned long)
                            @@ #SytGMulti(symmultup)#, (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%, _w);
			}
		}
	}
    LSTFOR (TraGOutputs(transition), arc, ARC)
	{
	    if (LstEmpty(ArcGSymsum(arc)) ||
		(NetGAtoms(net) && (ArcGPlace(arc) == NetGMonPlace(net))))
		continue;
	    p = LstWhich(NetGPlaces(net), (char *) ArcGPlace(arc)) - 1;
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		{
		    if (SytGCffSym(symmultup))
			{
			    @+    if (0L != (unsigned long) (
		            PrintSymbol(f, SytGCffSym(symmultup));
		            @@))
		            @@        {
			    @+            TupSArity(_w, (unsigned)
			    @@ %SytGArity(symmultup)%);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            @+            TupSField(_w, (unsigned) %i%,
			            if (SymIsVariable(symbol))
				        @+ $VarGLabel(SymGVariable(symbol))$
			            else
				       {
					   @+ (DOMAIN) (
	                                   PrintSymbol(f, symbol);
				           @+)
				       }
				    @@);
				}
		            @+            PutOutArc(_trn, (unsigned long) (
		            PrintSymbol(f, SytGCffSym(symmultup));
                            @@), (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%, _w);
		            @@        }
			}
		    else
			{
			    @+    TupSArity(_w, (unsigned)
			    @@ %SytGArity(symmultup)%);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            @+    TupSField(_w, (unsigned) %i%,
			            if (SymIsVariable(symbol))
				        @+ $VarGLabel(SymGVariable(symbol))$
			            else
				       {
					   @+ (DOMAIN) (
	                                   PrintSymbol(f, symbol);
				           @+)
				       }
				    @@);
				}
		            @+    PutOutArc(_trn, (unsigned long)
                            @@ #SytGMulti(symmultup)#, (unsigned) /*$PlaGName(ArcGPlace(arc))$*/%p%, _w);
			}
		}
	}
    @@    TrnReform(_trn);
    @@}
}

/***************************************************************************
*
* Function:  ERoutine
* Purpose:   Together with DRoutine and IRoutine, this routine produces
*            the unfolding of a high level transition.
* Arguments:
* Returns:
* See also:  DRoutine, IRoutine, FRoutine
*
****************************************************************************
*/
FE0(void, ERoutine)
{
    @@FE0(void, _E%t%)/*$TraGName(transition)$*/
    @@{
    if (letVarCount)
        {
            LSTFOR (TraGVariables(transition), variable, VARIABLE)
                VarReset(variable);
            LSTFOR (TraGGates(transition), gate, SYMBOL)
                SymReset(symbol);
            if (letVarCount & 1)
                {
                    LSTFOR (TraGVariables(transition), variable, VARIABLE)
                        if (VarIsLet(variable))
                            {
                                VarSet(variable);
                                VarCEscape(variable);
                            }
                        else
                            break;
                    WhatNew(TraGArcs(transition), FALSE);
                }
            else
                {
                    i = 0;
                    LSTFOR (TraGVariables(transition), variable, VARIABLE)
                        if (VarIsLet(variable))
                            {
                                @+    $VarGLabel(variable)$ =
                                @@ TupGField(_w, (unsigned) %i%);
                                VarSet(variable);
                                VarCEscape(variable);
                                WhatNew(TraGArcs(transition), FALSE);
                                i++;
                            }
                }
        }
    if (NetGNofClasses(net) != 1)
	@@    _class = 0;
    if (!NetGMonPlace(net))
	@@    _visible = PtDefVis() ? 1 : 0;
    if (!TraGComputation(transition))
	@@    _D%t%();
    else
	{
	    if (NetGNofClasses(net) != 1)
                @@##define Precedence(class) (_class = (class))
	    if (!NetGMonPlace(net))
		{
                    @@##define Visible() (_visible = 1)
                    @@##define Invisible() (_visible = 0)
		}
            @@##define Accept() _D%t%()
	    @+    {
	    LSTFOR (TraGComputation(transition), str, char)
		@+$str$
	    @@}
	    if (NetGNofClasses(net) != 1)
                @@##undef Precedence
	    if (!NetGMonPlace(net))
		{
                    @@##undef Visible
                    @@##undef Invisible
		}
            @@##undef Accept
	}
    @@}
}
