/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  mace.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen, Kimmo Valkealahti, and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See lxymace.c and ytbmace.c.
*
* Version history:
*     $Log$
***************************************************************************/

DE0(int, MaceYLex)
DE0(int, MaceYLds)
DE0(int, MaceYPrs)
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#ifndef YY2DEBUG
#define YY2DEBUG 1
#endif
#ifndef YY3DEBUG
#define YY3DEBUG 1
#endif
#ifndef YY4DEBUG
#define YY4DEBUG 1
#endif
#ifndef YY_NO_UNPUT
#define YY_NO_UNPUT
#endif
#ifndef YY2_NO_UNPUT
#define YY2_NO_UNPUT
#endif
#ifndef YY3_NO_UNPUT
#define YY3_NO_UNPUT
#endif
#ifndef YY4_NO_UNPUT
#define YY4_NO_UNPUT
#endif
#ifdef yyerror
#undef yyerror
#endif
#ifdef yy2error
#undef yy2error
#endif
#ifdef yy3error
#undef yy3error
#endif
#ifdef yy4error
#undef yy4error
#endif
#define yyerror(m) ((void) fprintf(_err, "%s\n", m), (void) fflush(_err))
#define yy2error(m) yyerror(m)
#define yy3error(m) yyerror(m)
#define yy4error(m) yyerror(m)
#ifdef yywrap
#undef yywrap
#endif
#ifdef yy2wrap
#undef yy2wrap
#endif
#ifdef yy3wrap
#undef yy3wrap
#endif
#ifdef yy4wrap
#undef yy4wrap
#endif
#define yywrap O_n_e
#define yy2wrap yywrap
#define yy3wrap yywrap
#define yy4wrap yywrap
#ifdef YY_INPUT
#undef YY_INPUT
#endif
#ifdef YY2_INPUT
#undef YY2_INPUT
#endif
#ifdef YY3_INPUT
#undef YY3_INPUT
#endif
#ifdef YY4_INPUT
#undef YY4_INPUT
#endif
#define YY_INPUT(buf,result,max_size) \
do \
    {  \
	register int _c_, _i_, _j_; \
        register char *_p_; \
 \
	for (_i_ = 0, _j_ = (max_size), _p_ = (buf); \
             _j_-- && ((_c_ = MbufGet(ioBuf)) != (int) EOF) && \
             ((char) _c_) && ((_p_[_i_++] = (char) _c_) != '\n');) \
	    ; \
	(result) = _i_; \
    } while (0)
#define YY2_INPUT(buf,result,max_size) YY_INPUT(buf, result, max_size)
#define YY3_INPUT(buf,result,max_size) YY_INPUT(buf, result, max_size)
#define YY4_INPUT(buf,result,max_size) YY_INPUT(buf, result, max_size)
#ifdef ECHO
#undef ECHO
#endif
#define ECHO (void) fwrite(MaceYText, (size_t) MaceYLeng, (size_t) 1, MaceYOut)
#ifdef isatty
#undef isatty
#endif
#define isatty Z_e_r_o
#ifdef fileno
#undef fileno
#endif
#define fileno(file) ((int) 0) 
#ifdef YY_MALLOC_DECL
#undef YY_MALLOC_DECL
#endif
#ifdef YY2_MALLOC_DECL
#undef YY2_MALLOC_DECL
#endif
#ifdef YY3_MALLOC_DECL
#undef YY3_MALLOC_DECL
#endif
#ifdef YY4_MALLOC_DECL
#undef YY4_MALLOC_DECL
#endif
#define YY_MALLOC_DECL
#define YY2_MALLOC_DECL
#define YY3_MALLOC_DECL
#define YY4_MALLOC_DECL
#ifdef alloca
#undef alloca
#endif
#define alloca(n) Allocate(n)
#define malloc(n) Allocate(n)
#define calloc(m,n) AllocArray(m,n)
#define realloc(p,n) Reallocate(p,n)
#define free(p) Deallocate((char *) (p))
#ifdef stdin
#undef stdin
#endif
#define stdin _in
#ifdef stdout
#undef stdout
#endif
#define stdout _out
#ifdef stderr
#undef stderr
#endif
#define stderr _err
#ifdef MaceYTyp
#undef MaceYTyp
#endif
#ifdef YYSTYPE
#undef YYSTYPE
#endif
#ifdef YY2STYPE
#undef YY2STYPE
#endif
#ifdef YY3STYPE
#undef YY3STYPE
#endif
#ifdef YY4STYPE
#undef YY4STYPE
#endif
#define YYSTYPE MaceYTyp
#define YY2STYPE YYSTYPE
#define YY3STYPE YYSTYPE
#define YY4STYPE YYSTYPE
typedef union 
{
    LIST *strl;
    LIST *ll;
    struct
	{
	    unsigned start, length;
	} token;
    struct
	{
	    unsigned start, length;
	    MACPELEM *macpElem;
	} macp;
} MaceYTyp;
extern unsigned macePlc;
extern char *MaceYText;
