/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  mbufs.h
*
* Part of: PROD's program probe
*
* Authors: Keijo Heljanko, Tomi Janhunen and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See mbufs.c.
*
* Version history:
*     $Log$
***************************************************************************/

typedef struct 
{
    char *_buf;
    char *_dupBuf;
    char *_written;
    char *_read;
    char *_max;
} MBUF;

#define MbufInit(mbuf) \
    ((mbuf)->_written = (mbuf)->_buf, (mbuf)->_read = (mbuf)->_buf)
#define MbufSize(mbuf) ((unsigned) ((mbuf)->_written - (mbuf)->_buf))
#define MbufGet(mbuf) \
    (((mbuf)->_read < (mbuf)->_written) \
     ? ((int) *((mbuf)->_read++)) : (int) EOF)

DE1(MBUF *, MbufCreate,
    unsigned, size)
DE1(void, MbufDracsid,
    MBUF *, mbuf)
#define MbufDiscard(mbuf) (MbufDracsid(mbuf), (mbuf) = (MBUF *) NULL)
DE2(void, MbufPut,
    MBUF *, mbuf,
    int, ch)
DE2(void, MbufStr,
    MBUF *, mbuf,
    char *, str)
#ifdef USE_READLINE
extern UCHAR *rdlnBffr;
extern UCHAR *rdlnPntr;
extern BOOL rdlnEof;
extern BOOL rdlnHist;
DE0(void, MbufRlInit)
DE0(void, MbufRlClose)
DE1(int, MbufFgetc,
    char *, prompt)
DE4(void, MbufReadln,
    MBUF *, mbuf,
    FILE *, file,
    char *, prompt,
    BOOL, use_readline)
#else
DE2(void, MbufReadln,
    MBUF *, mbuf,
    FILE *, file)
#endif
