/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  place.h
*
* Part of: PROD's program prpp
*
* Authors: Johannes Helander and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See place.c.
*
* Version history:
*     $Log$
***************************************************************************/

#define TOKEN_MATCH(Token, Expect_sym, Expect_string) \
do \
    { \
        if ((((PP_TOKEN *) NULL) == (Token)) || \
	    ((Token)->type != (Expect_sym))) \
	    { \
		register char *_sa_, *_sb_; \
 \
		_sa_ = (Expect_string); \
		_sb_ = (_sa_ == errStr) ? StrCopy(_sa_) : _sa_; \
		(void) sprintf(errStr, "Expected %s,\ngot %s%s%s", _sb_, \
			       ((Token) && ((Token)->type != PPNEWLINE)) \
			       ? "\"" : "", \
			       (!(Token)) ? "end of file" \
			       : (((Token)->type == PPNEWLINE) ? "newline" \
				  : (Token)->token), \
			       ((Token) && ((Token)->type != PPNEWLINE)) \
			       ? "\"" : ""); \
		if (_sb_ != _sa_) \
		    Deallocate((char *) _sb_); \
		if (((PP_TOKEN *) NULL) != (Token)) \
		    { \
			error(errStr); \
			if ((Token)->type == PPNEWLINE) \
			    unget_token(Token); \
			goto recover; \
		    } \
		else \
		    panic(errStr); \
	    } \
    } while (0)

#define TOKEN_CHECK(Token) \
do \
    { \
	if (((PP_TOKEN *) NULL) == (Token)) \
	    panic("Unexpected end of file"); \
	else if ((Token)->type == PPNEWLINE) \
	    { \
		unget_token(Token); \
		goto completed; \
	    } \
    } while (0)

DE0(void, read_tokens_match_newline)
DE0(PP_TOKEN *, gTSkSpace)
DE0(PP_TOKEN *, gTSkEolAndSpace)
DE0(void, pla)
DE0(void, tester)
