/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  probe.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen, Ismo Kangas, Marko Rauhamaa, Kimmo Valkealahti,
*          and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See probe.c.
*
* Version history:
*     $Log$
***************************************************************************/

extern unsigned long compCount;
extern PTRBL *comps;
extern BOOL echoInput;
extern char *prefDefault;
extern char *sourceName;
extern char *probHelp;

extern BOOL unfold;
extern BOOL symmMethod;
extern PTRBL *placeFoldings;
extern PTRBL *transFoldings;

extern BOOL sgsInMemory;
extern BOOL forIsOpen;

typedef struct PTHSET
{
    unsigned long number;
    char *description;
    BALTREE *paths;
} PTHSET;

#define PtsGNumber(pthSet) ((pthSet)->number)
#define PtsGDescription(pthSet) ((pthSet)->description)
#define PtsGPaths(pthSet) ((pthSet)->paths)
#define PtsSPaths(pthSet,_paths) ((pthSet)->paths = (_paths))
#define PtsAlloc() ((PTHSET *) Allocate(sizeof(PTHSET)))
extern BALTOOLS ptsBalTools;

extern BALTREE *specSets, *clbleSets, *freeSets;
extern BALTREE *trivMace;

DE3(PTHSET *, PtsCons,
    unsigned long, number,
    char *, description,
    BALTREE *, paths)
DE1(PTHSET *, PtsCopy,
    PTHSET *, pthSet)
DE1(void, PtsDracsid,
    PTHSET *, pthSet)
#define PtsDiscard(pthSet) (PtsDracsid(pthSet), (pthSet) = (PTHSET *) NULL)
#ifdef DEBUG
DE2(void, PtsDump,
    PTHSET *, pthSet,
    unsigned, depth)
#endif
DE2(int, PtsKeyCmp,
    PTHSET *, pthSet,
    unsigned long *, key)
DE2(BOOL, PtsPrefix,
    PTHSET *, pthSet,
    unsigned long *, prefix)
DE2(void, Execute,
    COMLINE *, comLine,
    char *, command)
DE0(void, MacpClean)
DE0(void, MaceClean)
DE0(void, RulesClean)
DE0(void, PrbMemClose)
