/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  prod.h
*
* Part of: PROD's programs araprod, "gphgen", probe, prod, prpp,
*          strong, and t
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module contains macros that are needed everywhere in PROD.
*     There is no need to include prod.h in a net description. A user
*     of PROD does not have to know anything about the below macros.
*     (Manuals or reports claiming the opposite are out of date.)
*     The used definition of DOMAIN guarantees that no information
*     is lost in conversions from other integer types to the DOMAIN
*     type. (We do not use the plain long type because it would be more
*     sensitive to overflows in positive arithmetic. Nobody really needs
*     negative tuple fields.)
*
* Version history:
*     $Log$
***************************************************************************/

#include <stdio.h>
#include <string.h>
#if (defined(UNIX) || defined(TNIL))
#include <sys/types.h>
#else
#include <sys\types.h>
#endif
#include <ctype.h>
#include <stdlib.h>
#include <malloc.h>
#include <errno.h>
#ifdef UNIX
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#else
#include <time.h>
#endif
#include <signal.h>
#include <assert.h>
#if (defined(UNIX) && defined(USE_READLINE))
#include "readline/readline.h"
#include "readline/history.h"
#endif

#if (defined(UNIX) && !defined(S_IRWXU))
#define S_IRWXU 0000700
#define S_IRUSR 0000400
#define S_IWUSR 0000200
#define S_IXUSR 0000100
#define S_IRWXG 0000070
#define S_IRGRP 0000040
#define S_IWGRP 0000020
#define S_IXGRP 0000010
#define S_IRWXO 0000007
#define S_IROTH 0000004
#define S_IWOTH 0000002
#define S_IXOTH 0000001
#endif

#ifndef SEEK_SET
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#endif

#ifndef NULL
#define NULL 0x0
#endif
#ifndef DOMAIN
#define DOMAIN unsigned long
#define UDOMAIN unsigned long
#define MINDOMAIN 0L
#define MAXDOMAIN (~MINDOMAIN)
#define DOMFORMAT "%lu"
#define UDOMFORMAT "%lu"
#define DOMXFORMAT "0x%lx"
#endif
#ifndef BITSPERBYTE
#define BITSPERBYTE 8
#endif
#ifndef MAX8
#define MAX8 0xff
#endif
#ifndef MAXS8
#define MAXS8 0x7f
#endif
#ifndef MINS8
#define MINS8 ((-MAXS8) - 1)
#endif
#ifndef MAX16
#define MAX16 0xffff
#endif
#ifndef MAXS16
#define MAXS16 0x7fff
#endif
#ifndef MINS16
#define MINS16 ((-MAXS16) - 1)
#endif
#ifndef MAX32
#define MAX32 0xffffffff
#endif
#ifndef MAXS32
#define MAXS32 0x7fffffff
#endif
#ifndef MINS32
#define MINS32 ((-MAXS32) - 1)
#endif
#ifndef UCHAR
#define UCHAR unsigned char
#endif
#ifndef DATATYPE
#define DATATYPE unsigned char
#endif
#ifndef BOOL
#define BOOL int
#endif
#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif
#ifndef VOID
#define VOID void
#endif
#ifndef DIRCHAR
#ifdef UNIX
#define DIRCHAR '/'
#else
#define DIRCHAR '\\'
#endif
#endif
