/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  prodmac.h
*
* Part of: PROD's program prod
*
* Authors: James Reilly and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See prodmac.c.
*
* Version history:
*     $Log$
***************************************************************************/

#define HS_UNDEFINED 0
#define HS_PROGRAM 1
#define HS_USER 2

typedef struct t_macro
{
    char * name;
    int has_value;
    char * value;
    BOOL matched;
    struct t_macro * next; 
} Macro;

#define BUFFER_SIZE BUFSIZ

extern char expansion[BUFFER_SIZE];
extern char ex_name[BUFFER_SIZE];

DE0(Macro *, new_macro)
DE1(char *, stringAlloc,
    char *, s2)
DE2(Macro *, argv_macro,
    Macro *, macro,
    char *, string)
DE2(Macro *, argv_target,
    Macro *, macro,
    char *, string)
DE2(char *, expandMacro,
    Macro *,lookup,
    char *, str)
DE3(Macro *, push_macro,
    Macro *, macro,
    char *, name,
    char *, value)
DE2(Macro *, macro_find,
    Macro *, search,
    char *, name)
DE3(Macro *, add_macro,
    Macro *, head,
    char *, name,
    char *, value)
#ifdef DEBUG
DE2(void, print_macro,
    Macro *, macro,
    FILE *, strm)
#endif
