/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  prodtok.h
*
* Part of: PROD's program prod
*
* Authors: James Reilly and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This is the only direct include file of the ".c" files of
*     the batch program prod.
*
* Version history:
*     $Log$
***************************************************************************/

#include "absolute.h"
#include "prod.h"
#include "alloc.h"
#include "error.h"
#include "prodmac.h"
#include "cmdnm.h"

typedef struct t_target
{
    char * prefix;
    char * postfix;
    char * command;
    struct t_target * t_chain;
} Target;

#define TK_MACRO 0
#define TK_TARGET 1
#define TK_CONDITIONAL 2
#define TK_IGNORE 3
#define TK_OTHER 4

typedef struct t_token
{
    int type;
    union
	{
	    Macro  m;   /* macro */
	    Target t;   /* target rule */
	    Macro  c;   /* conditional */
	} u_tok;
} Token;

extern char ioBfr[BUFFER_SIZE];
extern char dupBuf[BUFFER_SIZE];
extern char *cuTaBaseName;
extern char *cuTaSuffix;
extern FILE *prodStream;
extern Token grep_token;
#ifdef DOSBATCH
extern FILE *batchFile;
#endif

DE1(char *, eat_space,
    char *, s)
DE1(Token *, regexp,
    char *, s)
DE0(char *, ReadLine)
DE3(void, handle_target,
    Macro *, thead,
    Macro *, mhead,
    char *, s)
