/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  token.h
*
* Part of: PROD's program prpp
*
* Authors: Heikki Suonsivu and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module defines the types of tokens. See also lexer.c.
*
* Version history:
*     $Log$
***************************************************************************/

#define PP_TOKEN_TYPE int

#define PPOPENING_BRACKET 0
#define PPOPENING_SQUARE_BRACKET 1
#define PPOPENING_PARENTHESIS 2
#define PPTUPLE_LEFT 3
#define PPQUOTED_EXPRESSION 4
#define PPSPACE 5
#define PPNAME 6
#define PPDV 7
#define PPSPECIAL 8
#define PPCLOSING_BRACKET 9
#define PPCLOSING_SQUARE_BRACKET 10
#define PPCLOSING_PARENTHESIS 11
#define PPNEWLINE 12
#define PPNUMBER 13
#define PPNOT 14
#define PPBINARY_NOT 15
#define PPMULTIPLY 16
#define PPDIVIDE 17
#define PPREMAINDER 18
#define PPPLUS 19
#define PPMINUS 20
#define PPSHIFT_LEFT 21
#define PPSHIFT_RIGHT 22
#define PPLESS_THAN 23
#define PPLESS_THAN_OR_EQUAL 24
#define PPMORE_THAN 25
#define PPMORE_THAN_OR_EQUAL 26
#define PPEQUAL 27
#define PPNOT_EQUAL 28
#define PPBINARY_AND 29
#define PPBINARY_XOR 30
#define PPBINARY_OR 31
#define PPAND 32
#define PPOR 33
#define PPCONDITIONAL 34
#define PPCOLON 35
#define PPCOMMA 36
#define PPTUPLE_RIGHT 37
#define PPTUPLE_RANGE 38
#define PPSEMICOLON 39
#define PPCOMMENT 40
#define PPNOTHING 41
#define PPNEVERMATCH 42

typedef struct PP_TOKEN
{
    char *token;
    PP_TOKEN_TYPE type;
} PP_TOKEN;

DE2(PP_TOKEN *, PpTokCons,
    char *, s,
    PP_TOKEN_TYPE, type)
DE1(void, PpTokDracsid,
    PP_TOKEN *, token)
#define PpTokDiscard(token) (PpTokDracsid(token), (token) = (PP_TOKEN *) NULL)
#ifdef DEBUG
DE2(void, PpTokDump,
    PP_TOKEN *, token,
    unsigned, depth)
#endif
extern TOOLS ppTokTools;

extern PP_TOKEN_TYPE closing_bracket_pair[4];
