/***************************************************************************
*
* Copyright (c) 1989 -- 2006
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  yypmacp.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen, Kimmo Valkealahti, and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module is needed for making a tolerable bison-based parser.
*
* Version history:
*     $Log$
***************************************************************************/

#include "absolute.h"
#include "prod.h"
#include "alloc.h"
#include "error.h"
#ifdef flex_int8_t
#undef flex_int8_t
#endif
#ifdef flex_int16_t
#undef flex_int16_t
#endif
#ifdef flex_int32_t
#undef flex_int32_t
#endif
#ifdef flex_uint8_t
#undef flex_uint8_t
#endif
#ifdef flex_uint16_t
#undef flex_uint16_t
#endif
#ifdef flex_uint32_t
#undef flex_uint32_t
#endif
#ifdef INT8_MIN
#undef INT8_MIN
#endif
#ifdef INT16_MIN
#undef INT16_MIN
#endif
#ifdef INT32_MIN
#undef INT32_MIN
#endif
#ifdef INT8_MAX
#undef INT8_MAX
#endif
#ifdef INT16_MAX
#undef INT16_MAX
#endif
#ifdef INT32_MAX
#undef INT32_MAX
#endif
#ifdef UINT8_MAX
#undef UINT8_MAX
#endif
#ifdef UINT16_MAX
#undef UINT16_MAX
#endif
#ifdef UINT32_MAX
#undef UINT32_MAX
#endif
#define flex_int8_t NOU8
#define flex_int16_t NOU16
#define flex_int32_t NOU32
#define flex_uint8_t UNS8
#define flex_uint16_t UNS16
#define flex_uint32_t UNS32
#define INT8_MIN MINS8
#define INT16_MIN MINS16
#define INT32_MIN MINS32
#define INT8_MAX MAXS8
#define INT16_MAX MAXS16
#define INT32_MAX MAXS32
#define UINT8_MAX MAX8
#define UINT16_MAX MAX16
#define UINT32_MAX MAX32
#ifdef MacpYText
#undef MacpYText
#endif
#ifdef yytext
#undef yytext
#endif
#ifdef yy2text
#undef yy2text
#endif
#ifdef yy3text
#undef yy3text
#endif
#ifdef yy4text
#undef yy4text
#endif
#define yytext MacpYText
#define yy2text yytext
#define yy3text yytext
#define yy4text yytext
#ifdef MacpYLval
#undef MacpYLval
#endif
#ifdef yylval
#undef yylval
#endif
#ifdef yy2lval
#undef yy2lval
#endif
#ifdef yy3lval
#undef yy3lval
#endif
#ifdef yy4lval
#undef yy4lval
#endif
#define yy2lval MacpYLval
#ifdef MacpYLex
#undef MacpYLex
#endif
#ifdef yylex
#undef yylex
#endif
#ifdef yy2lex
#undef yy2lex
#endif
#ifdef yy3lex
#undef yy3lex
#endif
#ifdef yy4lex
#undef yy4lex
#endif
#define yy2lex MacpYLex
#ifdef MacpYPrs
#undef MacpYPrs
#endif
#ifdef yyparse
#undef yyparse
#endif
#ifdef yy2parse
#undef yy2parse
#endif
#ifdef yy3parse
#undef yy3parse
#endif
#ifdef yy4parse
#undef yy4parse
#endif
#define yy2parse MacpYPrs
#ifdef MacpYLds
#undef MacpYLds
#endif
#ifdef yylex_destroy
#undef yylex_destroy
#endif
#ifdef yy2lex_destroy
#undef yy2lex_destroy
#endif
#ifdef yy3lex_destroy
#undef yy3lex_destroy
#endif
#ifdef yy4lex_destroy
#undef yy4lex_destroy
#endif
#define yy2lex_destroy MacpYLds
#ifdef MacpYLeng
#undef MacpYLeng
#endif
#ifdef yyleng
#undef yyleng
#endif
#ifdef yy2leng
#undef yy2leng
#endif
#ifdef yy3leng
#undef yy3leng
#endif
#ifdef yy4leng
#undef yy4leng
#endif
#define yy2leng MacpYLeng
#ifdef MacpYIn
#undef MacpYIn
#endif
#ifdef yyin
#undef yyin
#endif
#ifdef yy2in
#undef yy2in
#endif
#ifdef yy3in
#undef yy3in
#endif
#ifdef yy4in
#undef yy4in
#endif
#define yy2in MacpYIn
#ifdef MacpYOut
#undef MacpYOut
#endif
#ifdef yyout
#undef yyout
#endif
#ifdef yy2out
#undef yy2out
#endif
#ifdef yy3out
#undef yy3out
#endif
#ifdef yy4out
#undef yy4out
#endif
#define yy2out MacpYOut
#ifdef MacpYUnput
#undef MacpYUnput
#endif
#ifdef yyunput
#undef yyunput
#endif
#ifdef yy2unput
#undef yy2unput
#endif
#ifdef yy3unput
#undef yy3unput
#endif
#ifdef yy4unput
#undef yy4unput
#endif
#define yyunput MacpYUnput
